[hdu1394]Minimum Inversion Number(树状数组)

Minimum Inversion Number

Time Limit: 2000/1000 MS (Java/Others)    Memory Limit: 65536/32768 K (Java/Others)
Total Submission(s): 18395    Accepted Submission(s): 11168

Problem Description

The inversion number of a given number sequence a1, a2, ..., an is the number of pairs (ai, aj) that satisfy i < j and ai > aj.

For a given sequence of numbers a1, a2, ..., an, if we move the first m >= 0 numbers to the end of the seqence, we will obtain another sequence. There are totally n such sequences as the following:

a1, a2, ..., an-1, an (where m = 0 - the initial seqence)
a2, a3, ..., an, a1 (where m = 1)
a3, a4, ..., an, a1, a2 (where m = 2)
...
an, a1, a2, ..., an-1 (where m = n-1)

You are asked to write a program to find the minimum inversion number out of the above sequences.

Input

The input consists of a number of test cases. Each case consists of two lines: the first line contains a positive integer n (n <= 5000); the next line contains a permutation of the n integers from 0 to n-1.

Output

For each case, output the minimum inversion number on a single line.

Sample Input

10
1 3 6 9 0 8 5 7 4 2

Sample Output

16

Author

CHEN, Gaoli

Source

ZOJ Monthly, January 2003

Recommend

Ignatius.L

更更更

隔壁YNY看到就直接暴力,当然T了(哈哈哈一起笑他)

动动脑子,题目说是一个环

那么每转一次,就相当于把第一个数放到最后面

考虑第一个数对原有答案的贡献是a[1]-1,也就是小于它的个数(数据是1到n的排列)

最后一个数对原答案的贡献相反

那么移动后当前逆序对数就要减去比第一个数小的个数,再加上比它大的数的个数

这样我们求出一次移动后的逆序对数

这时候我们发现下一次移动直接修改答案就好,不需要改动树状数组

推出式子ans+=n-a[i]-(a[i]-1)

 1 #include<stdio.h>
 2 #include<stdlib.h>
 3 #include<string.h>
 4 #define LL long long
 5 int bit[5050]={0},n,a[5050];
 6 inline LL min(LL a,LL b){
 7     return a<b?a:b;
 8 }
 9 inline int lb(int x){
10     return x&(-x);
11 }
12 inline LL q(int x){
13     LL ans=0;
14     while(x){
15         ans+=bit[x];
16         x-=lb(x);
17     }
18     return ans;
19 }
20 inline int c(int x){
21     while(x<=n){
22         bit[x]++;
23         x+=lb(x);
24     }
25     return 0;
26 }
27 int main(){
28     while(scanf("%d",&n)!=EOF){
29         memset(bit,0,sizeof(bit));
30         LL ans=0;
31         for(int i=1;i<=n;i++){
32             scanf("%d",&a[i]);
33             a[i]++;
34             ans+=q(n)-q(a[i]);
35             c(a[i]);
36         }
37         LL mn=ans;
38         mn=min(mn,ans);
39         for(int i=1;i<=n;i++){
40             ans+=n-a[i]-(a[i]-1);
41             mn=min(mn,ans);
42         }
43         printf("%lld\n",mn);
44     }
45
46     return 0;
47 }
时间: 2024-08-25 07:48:47

[hdu1394]Minimum Inversion Number(树状数组)的相关文章

HDU 1394 Minimum Inversion Number 树状数组&amp;&amp;线段树

题目给了你一串序列,然后每次 把最后一个数提到最前面来,直到原来的第一个数到了最后一个,每次操作都会产生一个新的序列,这个序列具有一个逆序数的值,问最小的你逆序数的值为多少 逆序数么 最好想到的是树状数组,敲了一把很快,注意把握把最后一个数提上来对逆序数的影响即可, #include<iostream> #include<cstdio> #include<list> #include<algorithm> #include<cstring> #i

HDU 1394 Minimum Inversion Number (树状数组求逆序数)

Minimum Inversion Number Time Limit: 2000/1000 MS (Java/Others)    Memory Limit: 65536/32768 K (Java/Others) Total Submission(s): 13942    Accepted Submission(s): 8514 Problem Description The inversion number of a given number sequence a1, a2, ..., a

HDU 1394 Minimum Inversion Number (树状数组)

依旧是再练习下树状数组的使用: 题目大意:   给出N个数,这些数可以把后面的删掉然后放到最前面形成新的序列 可得到的N种情况,求出这N种情况哪种的逆序数最小 解题思路:   先求出第一个序列的逆序数,然后用很巧妙的办法求下一个序列的逆序数,直到全部求出 序列 4 5 2 1 3 6 ,此序列的逆序数为7,它等到的下一个序列为 5 2 1 3 6 4 看这个新序列的产生过程,首部删除4,尾部添加4 删除4,必然会使得这个序列的逆序数减少(4-1)个,因为4前面必定有4-1个数小于4 添加4,必然

HDU 1394 Minimum Inversion Number (树状数组求逆序对)

题目链接:http://acm.hdu.edu.cn/showproblem.php?pid=1394 题目让你求一个数组,这个数组可以不断把最前面的元素移到最后,让你求其中某个数组中的逆序对最小是多少. 一开始就求原来初始数组的逆序对,树状数组求或者归并方法求(可以看<挑战程序设计>P178),然后根据最前面的元素大小递推一下每次移到最后得到的逆序数,取最小值. 1 #include <iostream> 2 #include <cstdio> 3 #include

Minimum Inversion Number 数状数组

Minimum Inversion Number Time Limit:1000MS     Memory Limit:32768KB     64bit IO Format:%I64d & %I64u Submit Status Practice HDU 1394 Description The inversion number of a given number sequence a1, a2, ..., an is the number of pairs (ai, aj) that sat

hdu1394Minimum Inversion Number树状数组求逆序对水题

//ans[i]=ans[i-1]+(n+1)-2*num[i] //num[i]为输入时的数据 //ans[i]为m=i时的逆序数 //用树状数组求ans[0]的逆序对 #include<iostream> #include<cstdio> #include<cstring> using namespace std; const int maxn=5010; int num[maxn]; int tree[maxn]; int lowbit(int i) { retu

HDU1394 Minimum Inversion Number 【线段树】+【逆序数】

Minimum Inversion Number Time Limit: 2000/1000 MS (Java/Others)    Memory Limit: 65536/32768 K (Java/Others) Total Submission(s): 9864    Accepted Submission(s): 6069 Problem Description The inversion number of a given number sequence a1, a2, ..., an

hdu1394 Minimum Inversion Number 线段树和树状数组

题意: 输入一个长度 n 第二行给出长度为n的数组,数组的值刚好为0到n-1这n个数. 然后每次把数组的第一个数放到最后一个,放n-1次,共有n个排列,这n个排列就有n个逆序数,输出这n个逆序数的最小值. 我的做法: 1.每次输入a[i]后,都把a[i] ++; 2.求出第一个排列的逆序数 3.递推求出所有的逆序数 那怎么求1呢? 对于每一个a[i],求出1到i-1 中比它大的个数,然后相加,即可得.若用朴素的查找,肯定会超时的,所以这里就利用线段树或者树状数组来快速查找. 线段树版本: 1 #

HDU1394 Minimum Inversion Number 线段树+数学

Problem Description The inversion number of a given number sequence a1, a2, -, an is the number of pairs (ai, aj) that satisfy i < j and ai > aj. For a given sequence of numbers a1, a2, -, an, if we move the first m >= 0 numbers to the end of the